;------7/19/2011, Created by Jade @UMD-------
;script to clean images for cosmic rays
;calls on the epoxi_crrej routine, which uses imgclean.pro


;----------------------------------------------------
;old directory for original images: location of images that have just
;been downloaded and have not been cleaned of cosmic rays
datadir= '~/IDLWorkspace80/DixiDownlinks/UMD/'
;new directory for cleaned images
crrejdir_local = '~/IDLWorkspace80/JYdailyLCsSDC/data_final/original_crrej/'
;imagelist file: widest_ap_first.tab
inputfile = '~/IDLWorkspace80/centering/centers/plus_spc/final_calib/imagelist_41262.tab'
;----------------------------------------------------
readcol,inputfile,file,jd,doy,filter,xc,yc,frame,flag,hed,spc,ap,format='a,d,i,a,f,f,i,i,d,d,i',skip=2,/silent
lines=n_elements(file)
;loop thru images
for i=0,lines-1 do begin
   print,'Processing'+strtrim(doy[i],2)+'/'+file[i]+'...'
   ;read in image
   img = readfits(datadir+strtrim(doy[i],2)+'/'+file[i],hdr,/silent)
   dq = readfits(datadir+strtrim(doy[i],2)+'/'+file[i],ext=1,/silent)
   ;call on cleaning routine
   img = epoxi_crrej(img,mask,header=hdr)
   dq[where(mask eq 1)] += 128
   dir = crrejdir_local+string(doy[i],format='(i3.3)')
   ;make new DOY folder if neccessary
   if file_search(dir) eq '' then file_mkdir,dir
   ;write cleaned image to new directory
   writefits,crrejdir_local+strtrim(doy[i],2)+'/'+file[i],img,hdr
   writefits,crrejdir_local+strtrim(doy[i],2)+'/'+file[i],dq,/append
;stop
endfor

end
