;created 5/30/2012 by Jade @UM
;implements a correction to EPOXI images
;due to the DI spacecraft MRI CCD gap
;updated 03/11/2013 by sam/EPOXI for archive lien resolution: Changed comment on line 29
; from "...effectively compressing the 2 center rows to 2/3 pixel width each"
;   to "...effectively compressing each center row to 5/6 pixel width"
;----------------------------------------------------------------------
;new directory for gap-corrected images
jdir_full='~/IDLWorkspace80/JYdailyLCsSDC/data_final/crrej/compress_gap/'
;old directory for orginal images (already cleaned of cosmic rays)
dir='~/IDLWorkspace80/JYdailyLCsSDC/data_final/crrej/original_crrej/'
;image file list: widest_ap_first.tab
inputfile ='~/Desktop/products/widest_ap.tab'
;----------------------------------------------------------------------
readcol,inputfile,file,jd,doy,filter,xc,yc,frame,flag,hed,spc,ap,format='a,d,i,a,f,f,i,i,d,d,i',skip=2,/silent
;----------------------------------------------------------------------
;number of images to correct
ln=n_elements(file)

;image loop
for i=0,ln-1 do begin
   img=readfits(dir+strtrim(string(doy[i]),2)+'/'+file[i],hdr,/silent)
   print,strtrim(string(ln-i),2)+'...'
;top bound & bottom bound
   top= (frame[i]/2)+.5 & bot=(frame[i]/2)-1.5
   sz=size(img) & dim=sz[1] & bound=(dim/2)-.5 & half=dim/2
   ;storage for true brightness (undistorted image)
   temp_full=fltarr(dim,dim) & temp_half=fltarr(dim,dim)
   ;I. resample image, effectively compressing each center row to 5/6 pixel width
   ;create known positions for full interpolation
   top=fltarr(half) & top[0]=3 & top[1]=9
   for j=2,half-1 do top[j]=top[j-1]+6 ;filling in rest of positions
   bot=-top & full=[top,bot]
   xhave=full[sort(full)] ;known positions 
   ;create interpolate positions
   topw=top+1 & topw[half-1]-=1  
   botw=-[topw] 
   fullw=[topw,botw]   
   xwant=fullw[sort(fullw)] ;interpolate positions
   ;determine wanted values within a column
   for c=0,dim-1 do begin
      b4=img[c,*] ;column b4 correction
      aft=interpol(b4,xhave,xwant)
      temp_full[c,*]=aft ;column after correction
   endfor
   
;------------------------------------------------
;write corrected image to new directory 
   folder=string(doy[i],format='(i3.3)')+'/'
   if file_search(jdir_full+folder) eq '' then file_mkdir,jdir_full+folder
   writefits,jdir_full+folder+file[i],temp_full,hdr ;I. full
;------------------------------------------------
endfor
end
