;created 6/5/2012 by Jade @UM
;adjusts centroids from former assignment in original images 
;by 1/6 pixel (vertically), to current location in gap-corrected images 

;----------------------------------------------------------------------
;gap-corrected image directory: location of images having been
;corrected of CCD gap
jdir_full='~/IDLWorkspace80/JYdailyLCsSDC/data_final/crrej/compress_gap/'
;original image directory: location of images having not been
;corrected of CCD gap
dir='~/IDLWorkspace80/JYdailyLCsSDC/data_final/crrej/original_crrej/'
;image file list with original centroids before image gap-correction: widest_ap_first.tab
inputfile ='~/Desktop/products3/widest_ap_first.tab'
;working directory: a top level directory
outdir='~/Desktop/products3/'
readcol,inputfile,file,jd,doy,filter,xc,yc,frame,flag,hed,spc,ap,format='a,d,i,a,f,f,i,i,d,d,i',skip=2,/silent
;----------------------------------------------------------------------

;constants
ln=n_elements(file) & gain=28.5 & stdspc= 149597870.7
ycn1=fltarr(ln) & ycn2=fltarr(ln) ;adjusted centroid arrays

;image loop
for i=0,ln-1 do begin
   ;img=readfits(dir+strtrim(string(doy[i]),2)+'/'+file[i],hdr,/silent)
   ;sz=size(img) & dim=sz[1] & bound=(dim/2)-.5 & half=dim/2
;top bound & bottom bound
   top= (frame[i]/2)+.5 & bot=(frame[i]/2)-1.5 & bound=(frame[i]/2)-.5 & half=(frame[i]/2)
;centroid adjust full
   down=yc[i]-(1./6.) & up=yc[i]+(1./6.)
   case 1 of
      yc[i] ge top: begin
         ycn1[i]= down & xcn1[i]=xc[i] ;above gap, adjust former centroid 
      end
      yc[i] lt bot: begin
         ycn1[i]= up & xcn1[i]=xc[i] ;below gap, adjust former centroid
      end
      else: begin ;inside gap, re-measuring centroid using center_par.pro routine
         print,'reading corrected image (full)....now recenter: '+strtrim(string(file[i]),2)
         img_full=readfits(jdir_full+strtrim(string(doy[i]),2)+'/'+file[i],hdr,/silent)
         center_par, img_full,x0,y0,xi=xc[i],yi=yc[i],/noplot
         xcn1[i]=x0 & ycn1[i]=y0
      endelse
   endcase
endfor
print,'Done with recentering, now write the lists...'
;------------------------------------------------
;write to file for full adjust method, creating image file list with
;adjusted centroids after gap-correction: widest_ap.tab
openw,f,outdir+'widest_ap.tab',/get_lun
printf,f,'             File                   JD_mid      DOY     filter    X       Y     frame  flag  hed        s/c     widest-radius (pix)'
printf,f,'-----------------------------------------------------------------------------------------------------------------------------------'
fmtstr='(a29,d17.7,i5,a11,2f8.2,i6,i5,d9.4,f14.2,i9)'
for i=0,ln-1 do printf,f,file[i],jd[i],doy[i],filter[i],xcn1[i],ycn1[i],frame[i],flag[i],hed[i],spc[i],ap[i],format=fmtstr
close,f & free_lun,f

end
